QGIS Application - Bug report #17872

WFS 2.0.0 DescribeFeatureType : TypeNames vs TypeName

2018-01-16 06:10 PM - dr -

Status: Closed

Priority: Normal

Assignee: Alessandro Pasotti
Category: Web Services clients/WFS

Affected QGIS version:master
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution: fixed/implemented

Copied to github as #: 25767

Description

Only TypeNames should be supported in WFS 2.0 but QGIS WFS provider sends TypeName and WFS 2.0 layer cannot be added onto

the map.

Associated revisions

Revision ccb4c80f - 2018-01-23 06:51 PM - Alessandro Pasotti

[bugfix][wfs] Expand support for 2.0.0 TYPENAMES

Fixes #17872 - WFS 2.0.0 DescribeFeatureType : TypeNames vs TypeName

This PR introduces the plural form of TYPENAME for
2.0.0 WFS servers, with some additional logic to
allow for 2.0.0 servers that only support TYPENAME
for DescribeFeatureType: in this case, the singular
form is also tried in case the plural one fails.

There is still some work to do for transactional
support but at least the read-only client part
should now be ok.

Tests have been added to check that:
- TYPENAME form still works with old 2.0.0
- TYPENAMES form works with compliant 2.0.0

- choice geometry types are handled by calling
GetFeature and examining the result

Revision 2330b7fc - 2018-05-23 01:59 PM - Even Rouault

[WFS provider] Handle buggy servers that require plural form TYPENAMES for DescribeFeatureType (fixes #18882, refs #17872)

Some servers like http://geoportal.samregion.ru/wfs12 return an

error when issuing a REQUEST=DescribeFeatureType&VERSION=2.0.0& TYPENAME-=...

query, which is the conformant way

They expect the plural form TYPENAMES to be passed

As they return an exception when being provided with the singular form,
we can automate the retry with TYPENAMES.
Revision 839de2e2 - 2018-05-23 03:23 PM - Even Rouault

Merge pull request #7057 from rouault/fix_18882_alternate

[WFS provider] Revert to using singular TYPENAME keyword for WFS 2.0 DescribeFeature Type (fixes #18882, refs #17872)

History

#1 - 2018-01-22 05:51 PM - Alessandro Pasotti
- Assignee set to Alessandro Pasotti

Can you please provide the URL of the failing WFS endpoint?

#2 - 2018-01-22 08:35 PM - dr -

I've faced with this issue on the following service: http://geoportal.samregion.ru/wfs12

#3 - 2018-01-23 08:48 AM - Alessandro Pasotti
- Status changed from Open to Feedback
- Priority changed from High to Normal

Ok, thanks for attaching the test endpoint, here are my findings:

1. WFS client 2.0.0 in QGIS client is NOT fully implemented (transactions for example are not)

2. the example server is flawed: in DescribeFeatureType 2.0.0 request the parameter TYPENAME is not plural but singular:
http://docs.opengeospatial.org/is/09-025r2/09-025r2.html#147 but
http://geoportal.samregion.ru/wfs12?SERVICE=WFS&#38;REQUEST=DescribeFeature Type&#38;VERSION=2.0.0&#38; TYPENAME=EC 1058 33
3. the example server is buggy for an additional reason: if called without TYPENAME it should return all typenames instead of an error

I think we should close this ticket, and instead open a feature request for a complete WFS 2.0.0 implementation in the client, but that would be a complete

different story and it will probably need some funding.

#4 - 2018-01-23 09:08 AM - dr -

It looks like OGC WFS doc is inconsistent. If you look at the next section: http://docs.opengeospatial.org/is/09-025r2/09-025r2.html#148, it says: "The

typeNames parameter encodes the names of one or more features types that shall be described by the DescribeFeature Type operation." From GeoServer
docs http://docs.geoserver.org/stable/en/user/services/wfs/basics.html: "WFS 2.0.0 ... also changed typeName to typeNames although GeoServer will
accept either." So it seems that TYPENAME should be TYPENAMEs for WFS 2.0.0.

#5 - 2018-01-23 09:15 AM - Alessandro Pasotti

Yes, but the XML example also use the singular: http://docs.opengeospatial.org/is/09-025r2/09-025r2.html#146
Note that GeoServer (that IIRC is the reference implementation) also uses the singular form:
https://demo.geo-solutions.it/geoserver/tiger/ows?service=WFS&#38;version=2.0.0&#38;request=DescribeFeature Type&#38;typeName=tiger_roads
#6 - 2018-01-23 09:28 AM - dr -

I think that GeoServer instance which you are provide is old. TypeName issue was fixed at GeoServer recently (Nov 22, 2017):
https:/github.com/geoserver/geoserver/commit/025¢34b3bdd626af3ecd96392abc2a136312ccf8

#7 - 2018-01-23 06:55 PM - Alessandro Pasotti
- Status changed from Feedback to In Progress
- Pull Request or Patch supplied changed from No to Yes

PR: https://github.com/qgis/QGIS/pull/6145

#8 - 2018-01-24 07:48 AM - Anonymous
- % Done changed from 0 to 100

- Status changed from In Progress to Closed

Applied in changeset commit:qgis|ccb4c80f8a6d2bb179258f1ffecOdc9a447ca465.

#9 - 2018-01-24 08:00 AM - dr -

Thanks!

#10 - 2018-01-24 11:54 AM - Alessandro Pasotti

Please give it a try, the more tests we can do the better.

#11 - 2018-01-25 08:25 AM - dr -

Thanks again, now it works flawlessly.

#12 - 2018-01-25 08:27 AM - Alessandro Pasotti

Thank you for reporting the bug and thanks to all the sponsors and donors for allowing another bugfixing round!

QGIS 3 will be a killer application!

#13 - 2018-02-21 09:51 PM - Giovanni Manghi

- Resolution set to fixed/implemented
